//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include "FButtonRound.h"
#include "ShortCuts.h"
#pragma resource "FComponents.res"
#pragma hdrstop
#pragma option -5 -O2 -OS -d- -fp -O -Oi -Ov -vi- -w-eas

__fastcall FButtonRound::FButtonRound(TComponent* Owner)
	: TGraphicControl(Owner) {
 Width=64;
 Height=32;
 FKind = Standard;
 middlex = 32;
 middley = 16;
 clicked = false;
 FCaption = "OK";
 FEnabled = true;
 FRMenu = true;
 Font->Name = "MS Sans Serif";
 Font->Size = 10;
 Canvas->Font = Font;
 mouseover = false;
 Canvas->Brush->Color = 0x00dcdcdc;
 Canvas->Pen->Width = 2;
 PM = CreatePopupMenu();
 InsertMenu(PM,0x00000000,MF_BYPOSITION | MF_POPUP | MF_DISABLED,0,"win95");
 InsertMenu(PM,0x00000001,MF_BYPOSITION | MF_POPUP | MF_DISABLED,0,"standard");
 InsertMenu(PM,0x00000002,MF_BYPOSITION | MF_POPUP | MF_SEPARATOR,0,"");
 InsertMenu(PM,0x00000003,MF_BYPOSITION | MF_POPUP | MF_ENABLED,0,"Anzeige ndern");
 InsertMenu(PM,0x00000004,MF_BYPOSITION | MF_POPUP | MF_SEPARATOR,0,"");
}

namespace Fbuttonround {
 void __fastcall Register() {
  TComponentClass classes[1] = {__classid(FButtonRound)};
  RegisterComponents("FLoh!", classes, 0);
 }
}

void __fastcall FButtonRound::Paint() {
 Canvas->Font = Font;
 if (FEnabled != true) { PaintDisabled(); return; }
 switch(clicked) {
  case true: PaintClicked(); return;
  case false: PaintNormal(); return;
 }
}

void FButtonRound::PaintNormal() {
 Canvas->Brush->Color = 0x00dcdcdc;
 Canvas->Pen->Width = 2;
 switch(FKind) {
  case Win95: if (!mouseover) {
               register int H = Height;
               register int W = Width;
               Canvas->Pen->Width = 1;
               Canvas->Pen->Color = 0x007f7f7f;  //mittelgrau
               Canvas->Ellipse(0,0,W,H);
               Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
               Canvas->Pen->Width = 2;
               middlex = W/2;
               middley = H/2;
               cwidth = Canvas->TextWidth(FCaption);
               cheight = Canvas->TextHeight(FCaption);
               Canvas->TextOut(middlex-(cwidth/2)-1,middley-(cheight/2)-1,FCaption);
               return;
              }
              if (mouseover) {
               register int H = Height;
               register int W = Width;
               Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
               Canvas->Arc(1,1,W-1,H-1,0,H*2/3,W,H*1/3);
               Canvas->Ellipse(0,0,W,H);
               Canvas->Pen->Color = 0x007f7f7f;  //mittelgrau
               Canvas->Arc(2,2,W-2,H-2,0,H*2/3,W,H*1/3);
               Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
               Canvas->Arc(1,1,W-1,H-1,W,H*1/3,0,H*2/3);
               Canvas->Pen->Color = 0x00ffffff;  //wei
               Canvas->Arc(2,2,W-2,H-2,W,H*1/3,0,H*2/3);
               Canvas->Pen->Color = 0x00000000;  //schwarz
               Canvas->Pen->Width = 1;
               Canvas->Arc(0,0,W,H,0,0,0,0);
               Canvas->Pen->Width = 2;
               middlex = W/2;
               middley = H/2;
               cwidth = Canvas->TextWidth(FCaption);
               cheight = Canvas->TextHeight(FCaption);
               Canvas->TextOut(middlex-(cwidth/2)-1,middley-(cheight/2)-1,FCaption);
               return;
              }
  case Standard: register int H = Height;
                 register int W = Width;
                 Canvas->Pen->Color = 0x00000000;  //schwarz
                 Canvas->Pen->Width = 2;
                 Canvas->Ellipse(0,0,W,H);
                 Canvas->Pen->Width = 1;
                 Canvas->Arc(1,1,W-1,H-1,0,H*2/3,W,H*1/3);
                 Canvas->Pen->Color = 0x007f7f7f;  //mittelgrau
                 Canvas->Arc(2,2,W-2,H-2,0,H*2/3,W,H*1/3);
                 Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
                 Canvas->Arc(1,1,W-1,H-1,W,H*1/3,0,H*2/3);
                 Canvas->Pen->Color = 0x00ffffff;  //wei
                 Canvas->Arc(2,2,W-2,H-2,W,H*1/3,0,H*2/3);
                 Canvas->Pen->Color = 0x00000000;  //schwarz
                 Canvas->Arc(0,0,W,H,0,0,0,0);
                 Canvas->Pen->Width = 2;
                 middlex = W/2;
                 middley = H/2;
                 cwidth = Canvas->TextWidth(FCaption);
                 cheight = Canvas->TextHeight(FCaption);
                 Canvas->TextOut(middlex-(cwidth/2)-1,middley-(cheight/2)-1,FCaption);
                 return;
 }
}

void FButtonRound::PaintClicked() {
 Canvas->Pen->Color = 0x00000000;  //schwarz
 Canvas->Ellipse(0,0,Width,Height);
 Canvas->Arc(1,1,Width-1,Height-1,0,Height*2/3,Width,Height*1/3);
 Canvas->Arc(1,1,Width-1,Height-1,Width,Height*1/3,0,Height*2/3);
 Canvas->Pen->Color = 0x007f7f7f;  //mittelgrau
 Canvas->Arc(2,2,Width-2,Height-2,0,Height*2/3,Width,Height*1/3);
 Canvas->Arc(2,2,Width-2,Height-2,Width,Height*1/3,0,Height*2/3);
 Canvas->Pen->Color = 0x00dcdcdc;
 Canvas->Ellipse(3,3,Width-1,Height-1);
 Canvas->Brush->Color = 0x00dcdcdc;
 Canvas->Pen->Color = 0x00000000;  //schwarz
 Canvas->Pen->Width = 1;
 Canvas->Arc(0,0,Width,Height,0,0,0,0);
 Canvas->Pen->Width = 2;
 middlex = Width/2;
 middley = Height/2;
 cwidth = Canvas->TextWidth(FCaption);
 cheight = Canvas->TextHeight(FCaption);
 Canvas->TextOut(middlex-(cwidth/2),middley-(cheight/2),FCaption);
 return;
}

void FButtonRound::PaintDisabled() {
 Canvas->Pen->Color = 0x00000000;  //schwarz
 Canvas->Ellipse(0,0,Width,Height);
 Canvas->Arc(1,1,Width-1,Height-1,0,Height*2/3,Width,Height*1/3);
 Canvas->Pen->Color = 0x007f7f7f;  //mittelgrau
 Canvas->Arc(2,2,Width-2,Height-2,0,Height*2/3,Width,Height*1/3);
 Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
 Canvas->Arc(1,1,Width-1,Height-1,Width,Height*1/3,0,Height*2/3);
 Canvas->Pen->Color = 0x00ffffff;  //wei
 Canvas->Arc(2,2,Width-2,Height-2,Width,Height*1/3,0,Height*2/3);
 Canvas->Pen->Color = 0x00000000;  //schwarz
 Canvas->Pen->Width = 1;
 Canvas->Arc(0,0,Width,Height,0,0,0,0);
 Canvas->Pen->Width = 2;
 Canvas->Font->Color = clSilver;
 middlex = Width/2;
 middley = Height/2;
 cwidth = Canvas->TextWidth(FCaption);
 cheight = Canvas->TextHeight(FCaption);
 Canvas->TextOut(middlex-(cwidth/2)-1,middley-(cheight/2)-1,FCaption);
 Canvas->Font->Color = clBlack;
 return;
}

void __fastcall FButtonRound::SetCaption(AnsiString s) {
 FCaption = s;
 Repaint();
 return;
}

void __fastcall FButtonRound::SetBounds(int ALeft, int ATop, int AWidth, int AHeight) {
 middlex = AWidth/2;
 middley = AHeight/2;
 if (AWidth < 16) { AWidth = 16; }
 if (AHeight < 16) { AHeight = 16; }
 TGraphicControl::SetBounds(ALeft, ATop, AWidth, AHeight);
 return;
}

void __fastcall FButtonRound::SetEnabled(Boolean Value) {
 if (Value) { FEnabled = true; }
 else { FEnabled = false; }
 Repaint();
 return;
}

void __fastcall FButtonRound::CMMouseEnter(TMessage *Message) {
 mouseover = true;
 switch(FKind) {
  case Win95: Repaint(); return;
 }
}

void __fastcall FButtonRound::CMMouseLeave(TMessage *Message) {
 mouseover = false;
 switch(FKind) {
  case Win95: Repaint(); return;
 }
}

void __fastcall FButtonRound::SetKind(TKind k) {
 if (k != FKind) { FKind = k; Repaint(); return; }
}

void __fastcall FButtonRound::MouseDown(TMouseButton Button,TShiftState ShiftState,int x,int y) {
 if (Button == mbLeft) {
  if (FEnabled) {
   clicked = true;
   Repaint();
   return;
  }
 }
 if ((Button == mbRight) && (FRMenu)) {
  GetCursorPos(&p);
  register int a = 0;
  switch(FKind) {
   case Win95: ModifyMenu(PM,0x00000000,MF_BYPOSITION | MF_CHECKED | MF_DISABLED,0,"win95");
               ModifyMenu(PM,0x00000001,MF_BYPOSITION | MF_POPUP | MF_DISABLED,0,"standard");
               a = 0;
               break;
   case Standard: ModifyMenu(PM,0x00000000,MF_BYPOSITION | MF_POPUP | MF_DISABLED,0,"win95");
                  ModifyMenu(PM,0x00000001,MF_BYPOSITION | MF_CHECKED | MF_DISABLED,0,"standard");
                  a = 1;
                  break;
  }
  TrackPopupMenu(PM,TPM_LEFTALIGN,p.x-2,p.y-2,0,this->Parent->Handle,NULL);
  switch(a) {
   case 0: SetKind(Standard); break;
   case 1: SetKind(Win95); break;
  }
  return;
 }
}

void __fastcall FButtonRound::MouseUp(TMouseButton Button,TShiftState ShiftState,int x,int y) {
 if (FEnabled) {
  if (clicked) { clicked = false; Repaint(); }
 }
}

void __fastcall FButtonRound::SetFRMenu(Boolean b) {
 FRMenu = b;
}
