//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include "FCaption.h"
#include "ShortCuts.h"
#pragma resource "FComponents.res"
#pragma option -5 -O2 -OS -d- -fp -O -Oi -Ov -vi- -w-eas -w-bei
#pragma hdrstop

__fastcall FCaption::FCaption(TComponent* Owner)
	: TCustomControl(Owner) {
 Height = 18;
 Width = 256;
 Color = clBlue;
 Canvas->Pen->Color = Color;
 Canvas->Brush->Color = Color;
 Font->Color = clWhite;
 FFontColor = Font->Color;
 Font->Size = 8;
 Font->Name = "MS Sans Serif";
 FTextPos = 1;
 Canvas->Font = Font;
 rect.Top = 0;
 rect.Left = 0;
 FKind = VerticalLeftRight;
 Font->Style = Font->Style << fsBold;
 FFontBold = true;
 FNS = true;
 FFontSize = 8;
 FVariation = false;
 BtClose = CreateFCustomButton();
 BtNormalize = CreateFCustomButton();
 BtMinimize = CreateFCustomButton();
 BtMenu = CreateMenuButton();
 BtMenu->BtKind = FCustomButton::cbMenuButton;
 BtMenu->Width = 0;
 BtMenu->Height = 0;
 BtMenu->OnClick = OnBtMenuClick;
 BtClose->Width = 0;
 BtClose->Height = 0;
 BtNormalize->Width = 0;
 BtNormalize->Height = 0;
 BtMinimize->Width = 0;
 BtMinimize->Height = 0;
 BtNormalize->BtKind = FCustomButton::cbNormalize;
 BtMinimize->BtKind = FCustomButton::cbMinimize;
 ShowHint = true;
 Hint = Caption;
 Maximized = false;
 FShadow = false;
 BtMenu->Enabled = true;
 FAlign = false;
 FNumButtons = 2;
 MenuForm = new TForm((TComponent *)this);
 MenuForm->BorderStyle = bsNone;
 MenuForm->OnDeactivate = OnMenuLooseFocus;
 MenuForm->FormStyle = fsStayOnTop;
 MenuForm->SetBounds(0,0,66,0);
 MenuForm->Color =clBlack;
 MenuPanel = new FCustomMenuPanel((TComponent *)this);
 MenuPanel->Parent = MenuForm;
 MenuPanel->SetBounds(0,0,66,FNumButtons * 16 + 2);
 MBt1 = new FCustomMenuButton((TComponent *)this);
 MBt1->Parent = MenuPanel;
 MBt1->SetBounds(1,1,0,0);
 MBt1->OnClick = Bt1Click;
 MBt2 = new FCustomMenuButton((TComponent *)this);
 MBt2->Parent = MenuPanel;
 MBt2->SetBounds(1,17,0,0);
 MBt2->OnClick = Bt2Click;
 MBt3 = new FCustomMenuButton((TComponent *)this);
 MBt3->Parent = MenuPanel;
 MBt3->SetBounds(1,33,0,0);
 MBt3->OnClick = Bt3Click;
 MBt4 = new FCustomMenuButton((TComponent *)this);
 MBt4->Parent = MenuPanel;
 MBt4->SetBounds(1,49,0,0);
 MBt4->OnClick = Bt4Click;
 MBt5 = new FCustomMenuButton((TComponent *)this);
 MBt5->Parent = MenuPanel;
 MBt5->SetBounds(1,65,0,0);
 MBt5->OnClick = Bt5Click;
 MBt6 = new FCustomMenuButton((TComponent *)this);
 MBt6->Parent = MenuPanel;
 MBt6->SetBounds(1,81,0,0);
 MBt6->OnClick = Bt6Click;
 MBt7 = new FCustomMenuButton((TComponent *)this);
 MBt7->Parent = MenuPanel;
 MBt7->SetBounds(1,97,0,0);
 MBt7->OnClick = Bt7Click;
 MBt8 = new FCustomMenuButton((TComponent *)this);
 MBt8->Parent = MenuPanel;
 MBt8->SetBounds(1,113,0,0);
 MBt8->OnClick = Bt8Click;
 MBt9 = new FCustomMenuButton((TComponent *)this);
 MBt9->Parent = MenuPanel;
 MBt9->SetBounds(1,129,0,0);
 MBt9->OnClick = Bt9Click;
 init = true;
}

namespace Fcaption {
 void __fastcall Register() {
  TComponentClass classes[1] = {__classid(FCaption)};
  RegisterComponents("FLoh!", classes, 0);
 }
}

void __fastcall FCaption::SetFShadow(Boolean b) {
 if (b != FShadow) { FShadow = b; Repaint(); }
}

void __fastcall FCaption::MenuPopup(int x,int y) {
 MenuForm->OnDeactivate = NULL;
 MenuForm->Show();
 MenuForm->SetBounds(x,y,66,0);
 MenuPanel->Height = FNumButtons * 16 + 2;
 for (register int i = 0; i <= FNumButtons * 16 + 3; i++) {
  MenuForm->Height = i;
  MenuForm->Controls[0]->Top = FNumButtons * 16 + 3 - i;
  MenuForm->Update();
  MenuForm->SetFocus();
 }
 MenuForm->OnDeactivate = OnMenuLooseFocus;
}

void __fastcall FCaption::OnBtMenuClick(TObject *) {
 TPoint tmp;
 GetCursorPos(&tmp);
 MenuPopup(tmp.x - BtMenu->curX,tmp.y - BtMenu->curY + 16);
}

void __fastcall FCaption::OnMenuLooseFocus(TObject *) {
 MenuForm->Hide();
 MenuForm->Height = 0;
}

void __fastcall FCaption::SetMBt1C(AnsiString s) {
 MBt1->Caption = s; MBt1->Repaint(); MBt1C = s;
}

void __fastcall FCaption::SetMBt2C(AnsiString s) {
 MBt2->Caption = s; MBt2->Repaint(); MBt2C = s;
}

void __fastcall FCaption::SetMBt3C(AnsiString s) {
 MBt3->Caption = s; MBt3->Repaint(); MBt3C = s;
}

void __fastcall FCaption::SetMBt4C(AnsiString s) {
 MBt4->Caption = s; MBt4->Repaint(); MBt4C = s;
}

void __fastcall FCaption::SetMBt5C(AnsiString s) {
 MBt5->Caption = s; MBt5->Repaint(); MBt5C = s;
}

void __fastcall FCaption::SetMBt6C(AnsiString s) {
 MBt6->Caption = s; MBt6->Repaint(); MBt6C = s;
}

void __fastcall FCaption::SetMBt7C(AnsiString s) {
 MBt7->Caption = s; MBt7->Repaint(); MBt7C = s;
}

void __fastcall FCaption::SetMBt8C(AnsiString s) {
 MBt8->Caption = s; MBt8->Repaint(); MBt8C = s;
}

void __fastcall FCaption::SetMBt9C(AnsiString s) {
 MBt9->Caption = s; MBt9->Repaint(); MBt9C = s;
}

void __fastcall FCaption::Paint() {
 switch(FNS) {
  case true:
   switch(FKind) {
    case VerticalLeftRight: PaintNSVertLR();
                            if (FShowIcon) { PaintIcon(); }
                            if (FCaptionVar != "") { PaintText(); }
                            return;
    case VerticalRightLeft: PaintNSVertRL();
                            if (FShowIcon) { PaintIcon(); }
                            if (FCaptionVar != "") { PaintText(); }
                            return;
    case HorizontalTopBottom: PaintNSHorzTB();
                              if (FShowIcon) { PaintIcon(); }
                              if (FCaptionVar != "") { PaintText(); }
                              return;
    case HorizontalBottomTop: PaintNSHorzBT();
                              if (FShowIcon) { PaintIcon(); }
                              if (FCaptionVar != "") { PaintText(); }
                              return;
  }
  case false: PaintNormal();
              if (FShowIcon) { PaintIcon(); }
              if (FCaptionVar != "") { PaintText(); }
              return;
 }
}

void __fastcall FCaption::SetFNumButtons(register int i) {
 if (i < 0) { i = 0; }
 if (i > 9) { i = 9; }
 FNumButtons = i;
}

int inline __fastcall FCaption::DoColorVert(register int orig, register int i2) {
 register int ret;
 register float red;
 register float green;
 register float blue;
 register float i = i2;
 register float d;
 switch(orig) {
  case clBlack: red = 0x00; green = 0x00; blue = 0x00;
                d = (i * 100.0) / (float(Width) * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHex(red,green,blue); return ret;
  case clMaroon: red = 0x7f; green = 0x00; blue = 0x00;
                 d = (i * 100.0) / (float(Width) * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHex(red,green,blue); return ret;
  case clGreen: red = 0x00; green = 0x7f; blue = 0x00;
                d = (i * 100.0) / (float(Width) * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHex(red,green,blue); return ret;
  case clOlive: red = 0x80; green = 0x80; blue = 0x00;
                d = (i * 100.0) / (float(Width) * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHex(red,green,blue); return ret;
  case clNavy: red = 0x00; green = 0x00; blue = 0x80;
               d = (i * 100.0) / (float(Width) * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHex(red,green,blue); return ret;
  case clPurple: red = 0x80; green = 0x00; blue = 0x80;
                 d = (i * 100.0) / (float(Width) * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHex(red,green,blue); return ret;
  case clTeal: red = 0x00; green = 0x80; blue = 0x80;
               d = (i * 100.0) / (float(Width) * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHex(red,green,blue); return ret;
  case clGray: red = 0x80; green = 0x80; blue = 0x80;
               d = (i * 100.0) / (float(Width) * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHex(red,green,blue); return ret;
  case clSilver: red = 0xc0; green = 0xc0; blue = 0xc0;
                 d = (i * 100.0) / (float(Width) * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHex(red,green,blue); return ret;
  case clRed: red = 0xff; green = 0x00; blue = 0x00;
              d = (i * 100.0) / (float(Width) * 100.0);
              red = red * d; green = green * d; blue = blue * d;
              ret = RGBtoHex(red,green,blue); return ret;
  case clLime: red = 0x00; green = 0xff; blue = 0x00;
               d = (i * 100.0) / (float(Width) * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHex(red,green,blue); return ret;
  case clYellow: red = 0xff; green = 0xff; blue = 0x00;
                 d = (i * 100.0) / (float(Width) * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHex(red,green,blue); return ret;
  case clBlue: red = 0x00; green = 0x00; blue = 0xff;
               d = (i * 100.0) / (float(Width) * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHex(red,green,blue); return ret;
  case clFuchsia: red = 0xff; green = 0x00; blue = 0xff;
                  d = (i * 100.0) / (float(Width) * 100.0);
                  red = red * d; green = green * d; blue = blue * d;
                  ret = RGBtoHex(red,green,blue); return ret;
  case clAqua: red = 0x00; green = 0xff; blue = 0xff;
               d = (i * 100.0) / (float(Width) * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHex(red,green,blue); return ret;
  case clWhite: red = 0xff; green = 0xff; blue = 0xff;
                d = (i * 100.0) / (float(Width) * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHex(red,green,blue); return ret;
 }
 return 0x00000000;
}

int inline __fastcall FCaption::DoColorHorz(register int orig, register int i2) {
 register int ret;
 register float red;
 register float green;
 register float blue;
 register float i = i2;
 register float d;
 switch(orig) {
  case clBlack: red = 0x00; green = 0x00; blue = 0x00;
                d = (i * 100.0) / (18.0 * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHex(red,green,blue); return ret;
  case clMaroon: red = 0x7f; green = 0x00; blue = 0x00;
                 d = (i * 100.0) / (18.0 * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHex(red,green,blue); return ret;
  case clGreen: red = 0x00; green = 0x7f; blue = 0x00;
                d = (i * 100.0) / (18.0 * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHex(red,green,blue); return ret;
  case clOlive: red = 0x80; green = 0x80; blue = 0x00;
                d = (i * 100.0) / (18.0 * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHex(red,green,blue); return ret;
  case clNavy: red = 0x00; green = 0x00; blue = 0x80;
               d = (i * 100.0) / (18.0 * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHex(red,green,blue); return ret;
  case clPurple: red = 0x80; green = 0x00; blue = 0x80;
                 d = (i * 100.0) / (18.0 * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHex(red,green,blue); return ret;
  case clTeal: red = 0x00; green = 0x80; blue = 0x80;
               d = (i * 100.0) / (18.0 * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHex(red,green,blue); return ret;
  case clGray: red = 0x80; green = 0x80; blue = 0x80;
               d = (i * 100.0) / (18.0 * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHex(red,green,blue); return ret;
  case clSilver: red = 0xc0; green = 0xc0; blue = 0xc0;
                 d = (i * 100.0) / (18.0 * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHex(red,green,blue); return ret;
  case clRed: red = 0xff; green = 0x00; blue = 0x00;
              d = (i * 100.0) / (18.0 * 100.0);
              red = red * d; green = green * d; blue = blue * d;
              ret = RGBtoHex(red,green,blue); return ret;
  case clLime: red = 0x00; green = 0xff; blue = 0x00;
               d = (i * 100.0) / (18.0 * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHex(red,green,blue); return ret;
  case clYellow: red = 0xff; green = 0xff; blue = 0x00;
                 d = (i * 100.0) / (18.0 * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHex(red,green,blue); return ret;
  case clBlue: red = 0x00; green = 0x00; blue = 0xff;
               d = (i * 100.0) / (18.0 * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHex(red,green,blue); return ret;
  case clFuchsia: red = 0xff; green = 0x00; blue = 0xff;
                  d = (i * 100.0) / (18.0 * 100.0);
                  red = red * d; green = green * d; blue = blue * d;
                  ret = RGBtoHex(red,green,blue); return ret;
  case clAqua: red = 0x00; green = 0xff; blue = 0xff;
               d = (i * 100.0) / (18.0 * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHex(red,green,blue); return ret;
  case clWhite: red = 0xff; green = 0xff; blue = 0xff;
                d = (i * 100.0) / (18.0 * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHex(red,green,blue); return ret;
 }
 return 0x00000000;
}

int inline __fastcall FCaption::DoColorVertVariation(register int orig, register int i2) {
 register int ret;
 register float red;
 register float green;
 register float blue;
 register float i = i2;
 register float d;
 switch(orig) {
  case clBlack: red = 0x00; green = 0x00; blue = 0x00;
                d = (i * 100.0) / (float(Width) * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clMaroon: red = 0x7f; green = 0x00; blue = 0x00;
                 d = (i * 100.0) / (float(Width) * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clGreen: red = 0x00; green = 0x7f; blue = 0x00;
                d = (i * 100.0) / (float(Width) * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clOlive: red = 0x80; green = 0x80; blue = 0x00;
                d = (i * 100.0) / (float(Width) * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clNavy: red = 0x00; green = 0x00; blue = 0x80;
               d = (i * 100.0) / (float(Width) * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clPurple: red = 0x80; green = 0x00; blue = 0x80;
                 d = (i * 100.0) / (float(Width) * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clTeal: red = 0x00; green = 0x80; blue = 0x80;
               d = (i * 100.0) / (float(Width) * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clGray: red = 0x80; green = 0x80; blue = 0x80;
               d = (i * 100.0) / (float(Width) * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clSilver: red = 0xc0; green = 0xc0; blue = 0xc0;
                 d = (i * 100.0) / (float(Width) * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clRed: red = 0xff; green = 0x00; blue = 0x00;
              d = (i * 100.0) / (float(Width) * 100.0);
              red = red * d; green = green * d; blue = blue * d;
              ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clLime: red = 0x00; green = 0xff; blue = 0x00;
               d = (i * 100.0) / (float(Width) * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clYellow: red = 0xff; green = 0xff; blue = 0x00;
                 d = (i * 100.0) / (float(Width) * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clBlue: red = 0x00; green = 0x00; blue = 0xff;
               d = (i * 100.0) / (float(Width) * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clFuchsia: red = 0xff; green = 0x00; blue = 0xff;
                  d = (i * 100.0) / (float(Width) * 100.0);
                  red = red * d; green = green * d; blue = blue * d;
                  ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clAqua: red = 0x00; green = 0xff; blue = 0xff;
               d = (i * 100.0) / (float(Width) * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clWhite: red = 0xff; green = 0xff; blue = 0xff;
                d = (i * 100.0) / (float(Width) * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
 }
 return 0x00000000;
}

int inline __fastcall FCaption::DoColorHorzVariation(register int orig, register int i2) {
 register int ret;
 register float red;
 register float green;
 register float blue;
 register float i = i2;
 register float d;
 switch(orig) {
  case clBlack: red = 0x00; green = 0x00; blue = 0x00;
                d = (i * 100.0) / (18.0 * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clMaroon: red = 0x7f; green = 0x00; blue = 0x00;
                 d = (i * 100.0) / (18.0 * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clGreen: red = 0x00; green = 0x7f; blue = 0x00;
                d = (i * 100.0) / (18.0 * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clOlive: red = 0x80; green = 0x80; blue = 0x00;
                d = (i * 100.0) / (18.0 * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clNavy: red = 0x00; green = 0x00; blue = 0x80;
               d = (i * 100.0) / (18.0 * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clPurple: red = 0x80; green = 0x00; blue = 0x80;
                 d = (i * 100.0) / (18.0 * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clTeal: red = 0x00; green = 0x80; blue = 0x80;
               d = (i * 100.0) / (18.0 * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clGray: red = 0x80; green = 0x80; blue = 0x80;
               d = (i * 100.0) / (18.0 * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clSilver: red = 0xc0; green = 0xc0; blue = 0xc0;
                 d = (i * 100.0) / (18.0 * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clRed: red = 0xff; green = 0x00; blue = 0x00;
              d = (i * 100.0) / (18.0 * 100.0);
              red = red * d; green = green * d; blue = blue * d;
              ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clLime: red = 0x00; green = 0xff; blue = 0x00;
               d = (i * 100.0) / (18.0 * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clYellow: red = 0xff; green = 0xff; blue = 0x00;
                 d = (i * 100.0) / (18.0 * 100.0);
                 red = red * d; green = green * d; blue = blue * d;
                 ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clBlue: red = 0x00; green = 0x00; blue = 0xff;
               d = (i * 100.0) / (18.0 * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clFuchsia: red = 0xff; green = 0x00; blue = 0xff;
                  d = (i * 100.0) / (18.0 * 100.0);
                  red = red * d; green = green * d; blue = blue * d;
                  ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clAqua: red = 0x00; green = 0xff; blue = 0xff;
               d = (i * 100.0) / (18.0 * 100.0);
               red = red * d; green = green * d; blue = blue * d;
               ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
  case clWhite: red = 0xff; green = 0xff; blue = 0xff;
                d = (i * 100.0) / (18.0 * 100.0);
                red = red * d; green = green * d; blue = blue * d;
                ret = RGBtoHexVariation(float(red),float(green),float(blue)); return ret;
 }
 return 0x00000000;
}

int inline __fastcall FCaption::RGBtoHex(register int red, register int green, register int blue) {
 red  = 0x00000001 * red; green = 0x00000100 * green; blue = 0x00010000 * blue;
 register int result;
 switch (FColorKind) {
  case ckSystem: result = red + green + blue + 0x00000000;
  case ckCurrent: result = red + green + blue + 0x01000000;
  case ckLogic: result = red + green + blue + 0x02000000;
 }
 return result;
}

int inline __fastcall FCaption::RGBtoHexVariation(register float red, register float green, register float blue) {
 red  = 0x00000001 * red; green = 0x00000100 * green; blue = 0x00010000 * blue;
 register int result;
 switch (FColorKind) {
  case ckSystem: result = red + green + blue + 0x00000000;
  case ckCurrent: result = red + green + blue + 0x01000000;
  case ckLogic: result = red + green + blue + 0x02000000;
 }
 return result;
}

void __fastcall FCaption::SetTextPos(register int i) {
 if (FTextPos != i) { FTextPos = i; Repaint(); }
}

void __fastcall FCaption::SetNS(Boolean b) {
 if (b != FNS) { FNS = b; Repaint(); }
}

void __fastcall FCaption::PaintNSVertLR() {
 for (register int i = 0; i <= Width; i++) {
  switch (FVariation) {
   case false: Canvas->Pen->Color = DoColorVert(Color,i);
               Canvas->Brush->Color = DoColorVert(Color,i);
               break;
   case true: Canvas->Pen->Color = DoColorVertVariation(Color,i);
              Canvas->Brush->Color = DoColorVertVariation(Color,i);
  }
  Canvas->MoveTo(Width - i,0);
  Canvas->LineTo(Width - i,19);
 }
}

void __fastcall FCaption::PaintNSVertRL() {
 for (register int i = Width; i >= 0; i--) {
  switch (FVariation) {
   case false: Canvas->Pen->Color = DoColorVert(Color,i);
               Canvas->Brush->Color = DoColorVert(Color,i);
               break;
   case true: Canvas->Pen->Color = DoColorVertVariation(Color,i);
              Canvas->Brush->Color = DoColorVertVariation(Color,i);
  }
  Canvas->MoveTo(i,0);
  Canvas->LineTo(i,19);
 }
}

void __fastcall FCaption::PaintNSHorzTB() {
 for (register int i = 0; i <= 18; i++) {
  switch (FVariation) {
   case false: Canvas->Pen->Color = DoColorHorz(Color,i);
               Canvas->Brush->Color = DoColorHorz(Color,i);
               break;
   case true: Canvas->Pen->Color = DoColorHorzVariation(Color,i);
              Canvas->Brush->Color = DoColorHorzVariation(Color,i);
  }
  Canvas->MoveTo(0,18 - i);
  Canvas->LineTo(Width + 1,18 - i);
 }
}

void __fastcall FCaption::PaintNSHorzBT() {
 for (register int i = 18; i >= 0; i--) {
  switch (FVariation) {
   case false: Canvas->Pen->Color = DoColorHorz(Color,i);
               Canvas->Brush->Color = DoColorHorz(Color,i);
               break;
   case true: Canvas->Pen->Color = DoColorHorzVariation(Color,i);
              Canvas->Brush->Color = DoColorHorzVariation(Color,i);
  }
  Canvas->MoveTo(0,i);
  Canvas->LineTo(Width + 1,i);
 }
}

void __fastcall FCaption::PaintNormal() {
 rect.Bottom = 18; rect.Right = Width;
 Canvas->Pen->Color = Color;
 Canvas->Brush->Color = Color;
 Canvas->FillRect(rect);
}

void __fastcall FCaption::PaintText() {
 switch(FTextCenter) {
  case true: PaintTextCentered(); return;
  case false: PaintTextNormal(); return;
 }
}

void __fastcall FCaption::SetTextCenter(Boolean b) {
 if (b != FTextCenter) { FTextCenter = b; Repaint(); }
}

void __fastcall FCaption::PaintTextCentered() {
 Canvas->Font = Font;
 Canvas->Brush->Style = bsClear;
 register int pos;
 if (FShadow) {
  Canvas->Font->Color = clBlack;
  pos = w2 - (Canvas->TextWidth(FCaptionVar) / 2);
  Canvas->TextOut(pos +	1,3,FCaptionVar);
  Canvas->Font->Color = FFontColor;
 }
 pos = w2 - (Canvas->TextWidth(FCaptionVar) / 2);
 Canvas->TextOut(pos,2,FCaptionVar);
}

void __fastcall FCaption::PaintTextNormal() {
 Canvas->Font = Font;
 Canvas->Brush->Style = bsClear;
  if (FShadow) {
  Canvas->Font->Color = clBlack;
  Canvas->TextOut(FTextPos + 1,3,FCaptionVar);
  Canvas->Font->Color = FFontColor;
 }
 Canvas->TextOut(FTextPos,2,FCaptionVar);
}

void __fastcall FCaption::SetFKind(TKindFCaption t) {
 if(FKind != t) { FKind = t; Repaint(); }
}

void __fastcall FCaption::SetFShowBtClose(Boolean b) {
 if (FShowBtClose != b) {
  FShowBtClose = b;
  BtClose->Visible = b;
  if (!b) {
   BtClose->Width = 0;
   BtClose->Height = 0;
   Repaint();
   return;
  }
  if (b) {
   BtClose->Width = 16;
   BtClose->Height = 14;
   Repaint();
   return;
  }
 }
}

void __fastcall FCaption::SetFShowBtNormalize(Boolean b) {
 if (FShowBtNormalize != b) {
  FShowBtNormalize = b;
  BtNormalize->Visible = b;
  if (!b) {
   BtNormalize->Width = 0;
   BtNormalize->Height = 0;
   Repaint();
   return;
  }
  if (b) {
   BtNormalize->Width = 16;
   BtNormalize->Height = 14;
   Repaint();
   return;
  }
 }
}

void __fastcall FCaption::SetFShowBtMinimize(Boolean b) {
 if (FShowBtMinimize != b) {
  FShowBtMinimize = b;
  BtMinimize->Visible = b;
  if (!b) {
   BtMinimize->Width = 0;
   BtMinimize->Height = 0;
   Repaint();
   return;
  }
  if (b) {
   BtMinimize->Width = 16;
   BtMinimize->Height = 14;
   Repaint();
   return;
  }
 }
}

void __fastcall FCaption::SetFShowBtMenu(Boolean b) {
 if (FShowBtMenu != b) {
  FShowBtMenu = b;
  BtMenu->Visible = b;
  if (!b) {
   BtMenu->Width = 0;
   BtMenu->Height = 0;
   Repaint();
   return;
  }
  if (b) {
   BtMenu->Width = 16;
   BtMenu->Height = 14;
   Repaint();
   return;
  }
 }
}

void __fastcall FCaption::SetBounds(int l, int t, int w, int h) {
 if (w < 128) { w = 128; }
 if (h < 18) { h = 18; }
 TCustomControl::SetBounds(l,t,w,h);
 if (init) {
  BtClose->Left = w - 19;
  BtNormalize->Left = w - 19 - 3 - 16;
  BtMinimize->Left = w - 19 - 3 - 16 - 16;
  BtMenu->Left = Width - BtMenu->Width - 64;
 }
}

void __fastcall FCaption::MouseDown(TMouseButton Button,TShiftState Shift,int X, int Y) {
 if ((Enabled) && (Button == mbLeft)) {
  if ((FShowIcon) && (X > 0) && (X < 17) && (Y > 0) && (Y >= 2) && (Y <= 16) && (FSystemMenu != NULL) && (!FMSEncarta)) {
   FSystemMenu->Popup(mouseco.x - X - 1,mouseco.y - Y + 17);
   return;
  }
  if ((FSystemMenu == NULL) && (FSystemMenuError)) {
   MessageBox(NULL,"Kein Systemmenu definiert!","Fehler",MB_OK | MB_ICONWARNING);
  }
 }
}

void __fastcall FCaption::PaintIcon() {
  DrawIconEx(Canvas->Handle,1,1,GetIcon(),16,16,NULL,Canvas->Brush->Handle,NULL);
}

void __fastcall FCaption::SetFShowIcon(Boolean b) {
 if (FShowIcon != b) { FShowIcon = b; Repaint(); }
 if (FShowIcon) {
  if (FTextPos < 18) { FTextPos = 18; Repaint(); }
 }
}

HICON FCaption::GetIcon() {
 switch(FIconKind) {
  case Default: hicon = LoadIcon((void *)HInstance,"MAINICON"); return hicon;
  case Information: hicon = LoadIcon(NULL,IDI_ASTERISK); return hicon;
  case Ausrufezeichen: hicon = LoadIcon(NULL,IDI_EXCLAMATION); return hicon;
  case Verboten: hicon = LoadIcon(NULL,IDI_HAND); return hicon;
  case Fragezeichen: hicon = LoadIcon(NULL,IDI_QUESTION); return hicon;
  case Winlogo: hicon = LoadIcon(NULL,IDI_WINLOGO); return hicon;
 }
 return hicon;
}

void __fastcall FCaption::SetFIconKind(TKindFCaptionIcon t) {
 FIconKind = t;
 if (FShowIcon) { Repaint(); return; }
}

void __fastcall FCaption::SetFFontBold(Boolean b) {
 if (b) { FFontBold = b; Font->Style = Font->Style << fsBold; Repaint(); }
 if (b != true) { FFontBold = b; Font->Style = Font->Style >> fsBold; Repaint(); }
}

void __fastcall FCaption::SetFFontItalic(Boolean b) {
 if (b) { FFontItalic = b; Font->Style = Font->Style << fsItalic; Repaint(); }
 if (b != true) { FFontItalic = b; Font->Style = Font->Style >> fsItalic; Repaint(); }
}

void __fastcall FCaption::SetFCaptionBtMenu(AnsiString s) {
 if (BtMenu->Caption != s) {
  BtMenu->Caption = s;
  FCaptionBtMenu = s;
  SetFShowBtMenu(BtMenu->Visible);
  BtMenu->Repaint();
 }
}

void __fastcall FCaption::SetFFontSize(register int i) {
 if (i != FFontSize) {
  switch(i) {
   case 8: FFontSize = 8; Font->Size = 8; Repaint(); return;
   case 10: FFontSize = 10; Font->Size = 10; Repaint(); return;
  }
 }
}

void __fastcall FCaption::SetFCaption(AnsiString s) {
 if (FCaptionVar != s) { FCaptionVar = s; if (ShowHint) { Hint = s; } Repaint(); }
}

void __fastcall FCaption::SetFSystemMenu(TPopupMenu *pm) {
 if (FSystemMenu != pm) { FSystemMenu = pm; }
}

void __fastcall FCaption::CMMouseEnter(TMessage *Message) {
 if (FOnMouseEnter != NULL) { FOnMouseEnter(this); }
}

void __fastcall FCaption::CMMouseLeave(TMessage *Message) {
 if (FOnMouseLeave != NULL) { FOnMouseLeave(this); }
}

void __fastcall FCaption::SetFSystemMenuError(Boolean b) {
 if (FSystemMenuError != b) { FSystemMenuError = b; }
}

void __fastcall FCaption::SetFColorKind(TKindFColor t) {
 if (FColorKind != t) { FColorKind = t; Repaint(); }
}

void __fastcall FCaption::SetFVariation(Boolean b) {
 if (FVariation != b) { FVariation = b; Repaint(); }
}

void __fastcall FCaption::SetFFontColor(TColor c) {
 if (FFontColor != c) { FFontColor = c; Font->Color = c; Repaint(); }
}

FCaption::FCustomButton *__fastcall FCaption::CreateFCustomButton() {
 FCustomButton *b = new FCustomButton((TComponent *)this);
 b->Parent = this;
 b->Visible = false;
 b->OnClick = BtnClick;
 return b;
}

FCaption::FCustomButton *__fastcall FCaption::CreateMenuButton() {
 FCustomButton *b = new FCustomButton((TComponent *)this);
 b->Parent = this;
 b->Visible = false;
 return b;
}

void __fastcall FCaption::SetMaximized(Boolean b) {
 FMaximized = b; Repaint();
 switch(b) {
  case true: BtNormalize->BtKind = FCustomButton::cbNormalize; return;
  case false: BtNormalize->BtKind = FCustomButton::cbMaximize; return;
 }
}

void __fastcall FCaption::SetFMSE(Boolean b) {
 if (FMSEncarta != b) {
  FMSEncarta = b;
  BtClose->MSEncartaStyle = b;
  BtMinimize->MSEncartaStyle = b;
  BtNormalize->MSEncartaStyle = b;
 }
}

void __fastcall FCaption::BtnClick(TObject *Sender) {
 if (Sender == BtClose) {
  if (FOnCloseClick != NULL) {
   FOnCloseClick(this);
   return;
  }
 }
 if (Sender == BtNormalize) {
  if (FOnNormalizeClick != NULL) {
   FOnNormalizeClick(this);
   return;
  }
 }
 if (Sender == BtMinimize) {
  if (FOnMinimizeClick != NULL) {
   FOnMinimizeClick(this);
   return;
  }
 }
}

void __fastcall FCaption::SetAlign(Boolean b) {
 FAlign = b;
 if (b) {
  Align = alTop;
  Repaint();
  return;
 }
 if (!b) {
  Align = alNone;
  Repaint();
  return;
 }
}

void __fastcall FCaption::Bt1Click(TObject *) {
 if (FOnMenuBt1Click != NULL) { FOnMenuBt1Click(this); }
}

void __fastcall FCaption::Bt2Click(TObject *) {
 if (FOnMenuBt2Click != NULL) { FOnMenuBt2Click(this); }
}

void __fastcall FCaption::Bt3Click(TObject *) {
 if (FOnMenuBt3Click != NULL) { FOnMenuBt3Click(this); }
}

void __fastcall FCaption::Bt4Click(TObject *) {
 if (FOnMenuBt4Click != NULL) { FOnMenuBt4Click(this); }
}

void __fastcall FCaption::Bt5Click(TObject *) {
 if (FOnMenuBt5Click != NULL) { FOnMenuBt5Click(this); }
}

void __fastcall FCaption::Bt6Click(TObject *) {
 if (FOnMenuBt6Click != NULL) { FOnMenuBt6Click(this); }
}

void __fastcall FCaption::Bt7Click(TObject *) {
 if (FOnMenuBt7Click != NULL) { FOnMenuBt7Click(this); }
}

void __fastcall FCaption::Bt8Click(TObject *) {
 if (FOnMenuBt8Click != NULL) { FOnMenuBt8Click(this); }
}

void __fastcall FCaption::Bt9Click(TObject *) {
 if (FOnMenuBt9Click != NULL) { FOnMenuBt9Click(this); }
}
// --------------- FCustomButton -----------------------
__fastcall FCaption::FCustomButton::FCustomButton(TComponent* Owner)
    : TCustomControl(Owner) {
 Width = 16;
 Height = 14;
 Top = 2;
 MouseOver = false;
 mousedown = false;
 FMSE = false;
 RBt.left = 0;
 RBt.top = 0;
 RBt.bottom = 14;
 RBt.right = 16;
 FKind = cbClose;
 Visible = false;
 Brush = new TBrush();
 Brush->Color = clSilver;
 Color = clSilver;
 Font->Size = 8;
 Font->Name = "MS Sans Serif";
 Font->Color = clBlack;
 Canvas->Font = Font;
 ControlStyle = ControlStyle << csOpaque;
 curX = 0;
 curY = 0;
 init = true;
}

void __fastcall FCaption::FCustomButton::SetKind(TKindFCustomButton t) {
 if (FKind != t) { FKind = t; Repaint(); }
}

void __fastcall FCaption::FCustomButton::Paint() {
 RBt.left = 0;
 RBt.top = 0;
 RBt.bottom = 14;
 RBt.right = 16;
 if (Visible) {
  switch(FKind) {
   case cbMinimize: if (mousedown != true) { DrawFrameControl(Canvas->Handle,&RBt,DFC_CAPTION,DFCS_CAPTIONMIN); }
                  if (mousedown) { DrawFrameControl(Canvas->Handle,&RBt,DFC_CAPTION,DFCS_CAPTIONMIN | DFCS_PUSHED); }
                  if ((FMSE) && (!MouseOver)) {
                   RBt.right -= 1;
                   RBt.bottom -= 1;
                   Brush->Color = clSilver;
                   FrameRect(Canvas->Handle,&RBt,Brush->Handle);
                   RBt.right += 1;
                   RBt.bottom += 1;
                  }
                  return;
   case cbMaximize: if (mousedown != true) { DrawFrameControl(Canvas->Handle,&RBt,DFC_CAPTION,DFCS_CAPTIONMAX	); }
                  if (mousedown) { DrawFrameControl(Canvas->Handle,&RBt,DFC_CAPTION,DFCS_CAPTIONMAX	 | DFCS_PUSHED); }
                  if ((FMSE) && (!MouseOver)) {
                   RBt.right -= 1;
                   RBt.bottom -= 1;
                   Brush->Color = clSilver;
                   FrameRect(Canvas->Handle,&RBt,Brush->Handle);
                   RBt.right += 1;
                   RBt.bottom += 1;
                  }
                  return;
   case cbClose: if (mousedown != true) { DrawFrameControl(Canvas->Handle,&RBt,DFC_CAPTION,DFCS_CAPTIONCLOSE); }
               if (mousedown) { DrawFrameControl(Canvas->Handle,&RBt,DFC_CAPTION,DFCS_CAPTIONCLOSE | DFCS_PUSHED); }
               if ((FMSE) && (!MouseOver)) {
                RBt.right -= 1;
                RBt.bottom -= 1;
                Brush->Color = clSilver;
                FrameRect(Canvas->Handle,&RBt,Brush->Handle);
                RBt.right += 1;
                RBt.bottom += 1;
               }
               return;
   case cbNormalize: if (mousedown != true) { DrawFrameControl(Canvas->Handle,&RBt,DFC_CAPTION,DFCS_CAPTIONRESTORE); }
                   if (mousedown) { DrawFrameControl(Canvas->Handle,&RBt,DFC_CAPTION,DFCS_CAPTIONRESTORE | DFCS_PUSHED); }
                   if ((FMSE) && (!MouseOver)) {
                    RBt.right -= 1;
                    RBt.bottom -= 1;
                    Brush->Color = clSilver;
                    FrameRect(Canvas->Handle,&RBt,Brush->Handle);
                    RBt.right += 1;
                    RBt.bottom += 1;
                  }
                  return;
   case cbMenuButton: PaintAsMenuButton(); return;
  }
 }
}

void __fastcall FCaption::FCustomButton::PaintAsMenuButton() {
 if ((Enabled) && (Visible)) {
  if ((!mousedown) && (MouseOver)) {
   Canvas->FillRect(rect);
   Canvas->MoveTo(0,Height + 1);
   Canvas->Pen->Color = 0x00ffffff;
   Canvas->LineTo(0,0);
   Canvas->LineTo(Width + 1,0);
   Canvas->Pen->Color = 0x00000000;
   Canvas->LineTo(Width + 1,Height + 1);
   Canvas->LineTo(0,Height + 1);
   Canvas->MoveTo(1,Height);
   Canvas->Pen->Color = 0x00dcdcdc;
   Canvas->LineTo(1,1);
   Canvas->LineTo(Width,1);
   Canvas->Pen->Color = 0x007f7f7f;
   Canvas->MoveTo(Width - 1,1);
   Canvas->LineTo(Width - 1,Height - 1);
   Canvas->LineTo(1,Height - 1);
   PaintText();
   return;
  }
  if ((!mousedown) && (!MouseOver)) {
   Canvas->Brush->Color = Color;
   Canvas->FillRect(rect);
   PaintText();
   return;
  }
 }
}

void __fastcall FCaption::FCustomButton::PaintText() {
 Canvas->Brush->Color = Color;
 Canvas->TextOut(w2 - (Canvas->TextWidth(Caption) / 2) - 1,h2 - (Canvas->TextHeight(Caption) / 2),Caption);
}

void __fastcall FCaption::FCustomButton::SetMSE(Boolean b) {
 if (FMSE != b) { FMSE = b; Repaint(); }
}

void __fastcall FCaption::FCustomButton::MouseDown(TMouseButton mb, TShiftState s, int X, int Y) {
 if (mb == mbLeft) {
  mousedown = true;
  Repaint();
  curX = X;
  curY = Y;
 }
}

void __fastcall FCaption::FCustomButton::MouseUp(TMouseButton mb, TShiftState s, int X, int Y) {
 if (mb == mbLeft) {
  mousedown = false;
  Repaint();
 }
}

void __fastcall FCaption::FCustomButton::CMMouseEnter(TMessage *m) {
 MouseOver = true; Repaint();
 if (FOnMouseEnter != NULL) { FOnMouseEnter(this); }
}

void __fastcall FCaption::FCustomButton::CMMouseLeave(TMessage *m) {
 MouseOver = false; Repaint();
 if (FOnMouseLeave != NULL) { FOnMouseLeave(this); }
}

void __fastcall FCaption::FCustomButton::SetBounds(int l, int t, int w, int h) {
 if ((init) && (BtKind != cbMenuButton)) {
  if ((w < 16) && (w != 0)) { w = 16; }
  if ((h < 14) && (h != 0)) { h = 14; }
 }
 if ((init) && (BtKind == cbMenuButton)) {
  w = 64;
  l = Parent->Width - w - 64;
 }
 TCustomControl::SetBounds(l,t,w,h);
 rect.Left = 0;
 rect.Top = 0;
 rect.Right = w;
 rect.Bottom = h;
}
// --------------- FCustomMenuButton -------------------
__fastcall FCaption::FCustomMenuButton::FCustomMenuButton(TComponent* Owner)
    : TCustomControl(Owner) {
 mousedown = false;
 mouseover = false;
 Width = 64;
 Height = 16;
 rect.Left = 0;
 rect.Top = 0;
 rect.Right = 64;
 rect.Bottom = 64;
 Color = clSilver;
}

void __fastcall FCaption::FCustomMenuButton::MouseDown(TMouseButton b,TShiftState,int,int) {
 if (b == mbLeft) { mousedown = true; Repaint(); }
}

void __fastcall FCaption::FCustomMenuButton::MouseUp(TMouseButton b,TShiftState,int,int) {
 if (b == mbLeft) { mousedown = false; Repaint(); }
}

void __fastcall FCaption::FCustomMenuButton::CMMouseEnter(TMessage *) {
 mouseover = true; Repaint();
}

void __fastcall FCaption::FCustomMenuButton::CMMouseLeave(TMessage *) {
 mouseover = false; Repaint();
}

void __fastcall FCaption::FCustomMenuButton::Paint() {
 Canvas->Pen->Color = Color;
 Canvas->Brush->Color = Color;
 Canvas->FillRect(rect);
 if ((mouseover) && (!mousedown)) {
  Canvas->Pen->Color = clWhite;
  Canvas->MoveTo(0,15);
  Canvas->LineTo(0,0);
  Canvas->LineTo(63,0);
  Canvas->Pen->Color = clBlack;
  Canvas->LineTo(63,15);
  Canvas->LineTo(0,15);
 }
 if (mousedown) {
  Canvas->Pen->Color = clBlack;
  Canvas->MoveTo(0,15);
  Canvas->LineTo(0,0);
  Canvas->LineTo(63,0);
  Canvas->Pen->Color = clWhite;
  Canvas->LineTo(63,15);
  Canvas->LineTo(0,15);
 }
 PaintText();
}

void __fastcall FCaption::FCustomMenuButton::SetBounds(int,int t,int,int) {
 TCustomControl::SetBounds(1,t,64,16);
}

void __fastcall FCaption::FCustomMenuButton::PaintText() {
 Canvas->Font->Size = 8;
 Canvas->Font->Name = "MS Sans Serif";
 Canvas->Font->Color =clBlack;
 Canvas->TextOut(2,2,Caption);
}

// --------------- FCustomMenuPanel --------------------
__fastcall FCaption::FCustomMenuPanel::FCustomMenuPanel(TComponent* Owner)
    : TCustomPanel(Owner) {
 Width = 64;
 BevelOuter = bvNone;
 Color = clBlack;
}

void __fastcall FCaption::FCustomMenuPanel::CMMouseLeave(TMessage *) {
 if (Parent != NULL) { Parent->Height = 0; Parent->Hide(); }
}
