//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#ifndef FCaptionH
#define FCaptionH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Windows.hpp>
//---------------------------------------------------------------------------
class FCaption : public TCustomControl
{
friend class FCustomButton;
private:
// --------------- FCustomButton -----------------------
    class FCustomButton : public TCustomControl
    {
    friend class FCaption;
	private:
	    enum TKindFCustomButton { cbMinimize, cbMaximize, cbClose, cbNormalize, cbMenuButton, cbItem };
	    void __fastcall SetMSE(Boolean);
   		void __fastcall SetKind(TKindFCustomButton);
	    void __fastcall PaintAsMenuButton();
	    void __fastcall PaintText();
    	bool FMSE;
	    bool MouseOver;
    	bool mousedown;
	    bool init;
        int curX;
        int curY;
	    TKindFCustomButton FKind;
    	RECT RBt;
	    TRect rect;
	    TBrush *Brush;
        TNotifyEvent FOnMouseEnter;
        TNotifyEvent FOnMouseLeave;
	protected:
	    void __fastcall Paint();
	    void __fastcall MouseDown(TMouseButton,TShiftState,int,int);
	    void __fastcall MouseUp(TMouseButton,TShiftState,int,int);
	    void __fastcall CMMouseEnter(TMessage *);
	    void __fastcall CMMouseLeave(TMessage *);
	public:
	    __fastcall FCustomButton(TComponent *);
	    void __fastcall SetBounds(int,int,int,int);
	__published:
	    __property Visible;
	    __property Font;
	    __property Color;
	    __property Caption;
	    __property OnClick;
	    __property Enabled;
        __property OnMouseDown;
	    __property Boolean MSEncartaStyle = { read = FMSE, write = SetMSE, default = false };
	    __property TKindFCustomButton BtKind = { read = FKind, write = SetKind, default = cbClose };
        __property TNotifyEvent OnMouseEnter = { read = FOnMouseEnter, write = FOnMouseEnter, nodefault };
        __property TNotifyEvent OnMouseLeave = { read = FOnMouseLeave, write = FOnMouseLeave, nodefault };
	BEGIN_MESSAGE_MAP
	    MESSAGE_HANDLER(CM_MOUSEENTER, TMessage *, CMMouseEnter);
	    MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage *, CMMouseLeave);
	END_MESSAGE_MAP(TCustomControl);
	};
// --------------- FCustomButton -----------------------
// --------------- FCustomMenuButton -------------------
	class FCustomMenuButton : TCustomControl
    {
    friend class FCaption;
    private:
      	bool mousedown;
        bool mouseover;
        TRect rect;
        void __fastcall PaintText();
    protected:
	    void __fastcall Paint();
	    void __fastcall MouseDown(TMouseButton,TShiftState,int,int);
	    void __fastcall MouseUp(TMouseButton,TShiftState,int,int);
	    void __fastcall CMMouseEnter(TMessage *);
	    void __fastcall CMMouseLeave(TMessage *);
    public:
       	__fastcall FCustomMenuButton(TComponent *);
        void __fastcall SetBounds(int,int,int,int);
    __published:
       	__property OnClick;
        __property Color;
        __property Caption;
        __property Font;
    BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(CM_MOUSEENTER, TMessage *, CMMouseEnter);
	    MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage *, CMMouseLeave);
	END_MESSAGE_MAP(TCustomControl);
    };
// --------------- FCustomMenuButton -------------------
// --------------- FCustomMenuPanel --------------------
	class FCustomMenuPanel : TCustomPanel
    {
    friend class FCaption;
    private:
    protected:
	    void __fastcall CMMouseLeave(TMessage *);
    public:
       	__fastcall FCustomMenuPanel(TComponent *);
    __published:
    	__property Color;
    BEGIN_MESSAGE_MAP
	    MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage *, CMMouseLeave);
	END_MESSAGE_MAP(TCustomPanel);
    };
// --------------- FCustomMenuPanel --------------------
    enum TKindFCaption { HorizontalTopBottom, HorizontalBottomTop, VerticalLeftRight, VerticalRightLeft };
    enum TKindFCaptionIcon { Default, Information, Ausrufezeichen, Verboten, Fragezeichen, Winlogo };
    enum TKindFColor { ckSystem, ckCurrent, ckLogic };
    int inline __fastcall DoColorVert(register int, register int);
    int inline __fastcall DoColorHorz(register int, register int);
    int inline __fastcall DoColorVertVariation(register int, register int);
    int inline __fastcall DoColorHorzVariation(register int, register int);
    int inline __fastcall RGBtoHex( register int, register int, register int);
    int inline __fastcall RGBtoHexVariation( register float, register float, register float);
    void __fastcall SetTextPos(register int);
    void __fastcall SetFFontSize(register int);
    void __fastcall SetFNumButtons(register int);
    void __fastcall SetNS(Boolean);
    void __fastcall SetTextCenter(Boolean);
    void __fastcall SetFKind(TKindFCaption);
    void __fastcall SetFIconKind(TKindFCaptionIcon);
    void __fastcall SetFColorKind(TKindFColor);
    void __fastcall SetFShowBtClose(Boolean);
    void __fastcall SetFShowBtNormalize(Boolean);
    void __fastcall SetFShowBtMinimize(Boolean);
    void __fastcall SetFShowIcon(Boolean);
    void __fastcall SetFFontBold(Boolean);
    void __fastcall SetFFontItalic(Boolean);
    void __fastcall SetFSystemMenuError(Boolean);
    void __fastcall SetFShadow(Boolean);
    void __fastcall SetFVariation(Boolean);
    void __fastcall SetMaximized(Boolean);
    void __fastcall SetFMSE(Boolean);
    void __fastcall SetFShowBtMenu(Boolean);
    void __fastcall SetFCaption(AnsiString);
    void __fastcall SetFCaptionBtMenu(AnsiString);
    void __fastcall SetMBt1C(AnsiString);
    void __fastcall SetMBt2C(AnsiString);
    void __fastcall SetMBt3C(AnsiString);
    void __fastcall SetMBt4C(AnsiString);
    void __fastcall SetMBt5C(AnsiString);
    void __fastcall SetMBt6C(AnsiString);
    void __fastcall SetMBt7C(AnsiString);
    void __fastcall SetMBt8C(AnsiString);
    void __fastcall SetMBt9C(AnsiString);
    void __fastcall SetFSystemMenu(TPopupMenu *);
    void __fastcall SetFExtraMenu(TPopupMenu *);
    void __fastcall SetFFontColor(TColor);
    void __fastcall SetAlign(Boolean);
    void __fastcall BtnClick(TObject *);
    void __fastcall OnBtMenuClick(TObject *);
    void __fastcall Bt1Click(TObject *);
    void __fastcall Bt2Click(TObject *);
    void __fastcall Bt3Click(TObject *);
    void __fastcall Bt4Click(TObject *);
    void __fastcall Bt5Click(TObject *);
    void __fastcall Bt6Click(TObject *);
    void __fastcall Bt7Click(TObject *);
    void __fastcall Bt8Click(TObject *);
    void __fastcall Bt9Click(TObject *);
    void __fastcall OnMenuLooseFocus(TObject *);
    void __fastcall PaintNSHorzTB();
    void __fastcall PaintNSHorzBT();
    void __fastcall PaintNSVertLR();
    void __fastcall PaintNSVertRL();
    void __fastcall PaintNormal();
    void __fastcall PaintText();
    void __fastcall PaintTextCentered();
    void __fastcall PaintTextNormal();
    void __fastcall PaintIcon();
    void __fastcall MenuPopup(int,int);
    int FTextPos;
    int FFontSize;
    int FNumButtons;
    bool FNS;
    bool FTextCenter;
    bool FShowBtClose;
    bool FShowBtNormalize;
    bool FShowBtMinimize;
    bool FShowIcon;
    bool FFontBold;
    bool FFontItalic;
    bool FSystemMenuError;
    bool OwnerIsTForm;
    bool FVariation;
    bool FMSEncarta;
    bool FMaximized;
    bool FAlign;
    bool FShowBtMenu;
    bool FBtMenuEnabled;
    bool FShadow;
    bool init;
    AnsiString FCaptionVar;
    AnsiString FCaptionBtMenu;
    AnsiString MBt1C;
    AnsiString MBt2C;
    AnsiString MBt3C;
    AnsiString MBt4C;
    AnsiString MBt5C;
    AnsiString MBt6C;
    AnsiString MBt7C;
    AnsiString MBt8C;
    AnsiString MBt9C;
    TRect rect;
    HICON GetIcon();
    HICON hicon;
    POINT mouseco;
    TKindFCaption FKind;
    TKindFCaptionIcon FIconKind;
    TKindFColor FColorKind;
    TNotifyEvent FOnCloseClick;
    TNotifyEvent FOnNormalizeClick;
    TNotifyEvent FOnMinimizeClick;
    TNotifyEvent FOnMouseEnter;
    TNotifyEvent FOnMouseLeave;
    TNotifyEvent FOnMenuBt1Click;
    TNotifyEvent FOnMenuBt2Click;
    TNotifyEvent FOnMenuBt3Click;
    TNotifyEvent FOnMenuBt4Click;
    TNotifyEvent FOnMenuBt5Click;
    TNotifyEvent FOnMenuBt6Click;
    TNotifyEvent FOnMenuBt7Click;
    TNotifyEvent FOnMenuBt8Click;
    TNotifyEvent FOnMenuBt9Click;
    TPopupMenu *FSystemMenu;
    TColor FFontColor;
    FCustomButton *__fastcall CreateFCustomButton();
    FCustomButton *__fastcall CreateMenuButton();
    FCustomButton *BtClose;
    FCustomButton *BtMinimize;
    FCustomButton *BtNormalize;
    FCustomButton *BtMenu;
    FCustomMenuButton *MBt1;
    FCustomMenuButton *MBt2;
    FCustomMenuButton *MBt3;
    FCustomMenuButton *MBt4;
    FCustomMenuButton *MBt5;
    FCustomMenuButton *MBt6;
    FCustomMenuButton *MBt7;
    FCustomMenuButton *MBt8;
    FCustomMenuButton *MBt9;
    TForm *MenuForm;
    FCustomMenuPanel *MenuPanel;
protected:
    void __fastcall Paint();
    void __fastcall MouseDown(TMouseButton,TShiftState,int,int);
    void __fastcall CMMouseEnter(TMessage *);
    void __fastcall CMMouseLeave(TMessage *);
public:
	__fastcall FCaption(TComponent* Owner);
    void __fastcall SetBounds(int,int,int,int);
__published:
    __property Color;
    __property Hint;
    __property ShowHint;
    __property OnClick;
    __property OnDblClick;
    __property OnMouseDown;
    __property OnMouseUp;
    __property OnMouseMove;
    __property ComponentStyle;
    __property int LeftTextPos = { read = FTextPos, write=SetTextPos, default = 1 };
    __property int FontSize = { read = FFontSize, write = SetFFontSize, default = 8 };
    __property int MenuButtons = { read = FNumButtons, write = SetFNumButtons, default = 2 };
    __property AnsiString Caption = { read = FCaptionVar, write = SetFCaption, nodefault };
    __property AnsiString CaptionBtMenu = { read = FCaptionBtMenu, write = SetFCaptionBtMenu, nodefault };
    __property AnsiString CaptionMenuBt1 = { read = MBt1C, write = SetMBt1C, nodefault };
    __property AnsiString CaptionMenuBt2 = { read = MBt2C, write = SetMBt2C, nodefault };
    __property AnsiString CaptionMenuBt3 = { read = MBt3C, write = SetMBt3C, nodefault };
    __property AnsiString CaptionMenuBt4 = { read = MBt4C, write = SetMBt4C, nodefault };
    __property AnsiString CaptionMenuBt5 = { read = MBt5C, write = SetMBt5C, nodefault };
    __property AnsiString CaptionMenuBt6 = { read = MBt6C, write = SetMBt6C, nodefault };
    __property AnsiString CaptionMenuBt7 = { read = MBt7C, write = SetMBt7C, nodefault };
    __property AnsiString CaptionMenuBt8 = { read = MBt8C, write = SetMBt8C, nodefault };
    __property AnsiString CaptionMenuBt9 = { read = MBt9C, write = SetMBt9C, nodefault };
    __property TColor FontColor = { read = FFontColor, write = SetFFontColor, default = clWhite };
    __property Boolean NewStyle = { read = FNS, write=SetNS, default = true };
    __property Boolean CenterText = { read = FTextCenter, write=SetTextCenter, default = false };
    __property Boolean ShowBtClose = { read = FShowBtClose, write = SetFShowBtClose, default = false };
    __property Boolean ShowBtNormalize = { read = FShowBtNormalize, write = SetFShowBtNormalize, default = false };
    __property Boolean ShowBtMinimize = { read = FShowBtMinimize, write = SetFShowBtMinimize, default = false };
    __property Boolean ShowIcon = { read = FShowIcon, write = SetFShowIcon, default = false };
    __property Boolean FontBold = { read = FFontBold, write = SetFFontBold, default = true };
    __property Boolean FontItalic = { read = FFontItalic, write = SetFFontItalic, default = false };
    __property Boolean SystemMenuError = { read = FSystemMenuError, write = SetFSystemMenuError, default = false };
    __property Boolean ColorVariation = { read = FVariation, write = SetFVariation, default = false };
    __property Boolean Maximized = { read = FMaximized, write = SetMaximized, default = false };
    __property Boolean MSEncartaStyle = { read = FMSEncarta, write = SetFMSE, default = false };
    __property Boolean AlignTop = { read = FAlign, write = SetAlign, default = false };
    __property Boolean ShowBtMenu = { read = FShowBtMenu, write = SetFShowBtMenu, default = false };
    __property Boolean Shadow = { read = FShadow, write = SetFShadow, default = false };
    __property TKindFCaption Kind = { read = FKind, write = SetFKind, default = VerticalLeftRight };
    __property TKindFCaptionIcon IconKind = { read = FIconKind, write = SetFIconKind, default = Default };
    __property TKindFColor ColorKind = { read = FColorKind, write = SetFColorKind, default = ckSystem };
    __property TNotifyEvent OnBtCloseClick = { read = FOnCloseClick, write = FOnCloseClick };
    __property TNotifyEvent OnBtNormalizeClick = { read = FOnNormalizeClick, write = FOnNormalizeClick };
    __property TNotifyEvent OnBtMinimizeClick = { read = FOnMinimizeClick, write = FOnMinimizeClick };
    __property TNotifyEvent OnMouseEnter = { read = FOnMouseEnter, write = FOnMouseEnter, nodefault };
    __property TNotifyEvent OnMouseLeave = { read = FOnMouseLeave, write = FOnMouseLeave, nodefault };
    __property TNotifyEvent OnMenuBt1Click = { read = FOnMenuBt1Click, write = FOnMenuBt1Click, nodefault };
    __property TNotifyEvent OnMenuBt2Click = { read = FOnMenuBt2Click, write = FOnMenuBt2Click, nodefault };
    __property TNotifyEvent OnMenuBt3Click = { read = FOnMenuBt3Click, write = FOnMenuBt3Click, nodefault };
    __property TNotifyEvent OnMenuBt4Click = { read = FOnMenuBt4Click, write = FOnMenuBt4Click, nodefault };
    __property TNotifyEvent OnMenuBt5Click = { read = FOnMenuBt5Click, write = FOnMenuBt5Click, nodefault };
    __property TNotifyEvent OnMenuBt6Click = { read = FOnMenuBt6Click, write = FOnMenuBt6Click, nodefault };
    __property TNotifyEvent OnMenuBt7Click = { read = FOnMenuBt7Click, write = FOnMenuBt7Click, nodefault };
    __property TNotifyEvent OnMenuBt8Click = { read = FOnMenuBt8Click, write = FOnMenuBt8Click, nodefault };
    __property TNotifyEvent OnMenuBt9Click = { read = FOnMenuBt9Click, write = FOnMenuBt9Click, nodefault };
    __property TPopupMenu *SystemMenu = { read = FSystemMenu, write = SetFSystemMenu, nodefault };
BEGIN_MESSAGE_MAP
    MESSAGE_HANDLER(CM_MOUSEENTER, TMessage *, CMMouseEnter);
    MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage *, CMMouseLeave);
END_MESSAGE_MAP(TCustomControl);
};
//---------------------------------------------------------------------------
#endif
