//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#ifndef FPanelH
#define FPanelH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
class FPanel : public TCustomPanel
{
private:
// --------------- FCustomButton -----------------------
    class FCustomButton : public TCustomControl
    {
    friend class FPanel;
    private:
        void __fastcall PaintText();
        void PaintPM();
        void __fastcall SetFPM(AnsiString);
        bool MouseOver;
        bool mousedown;
        bool init;
        bool nopaint;
        TRect rect;
        AnsiString FPM;
        TColor SignColor;
    protected:
        void __fastcall Paint();
        void __fastcall MouseDown(TMouseButton,TShiftState,int,int);
        void __fastcall MouseUp(TMouseButton,TShiftState,int,int);
        void __fastcall CMMouseEnter(TMessage *);
        void __fastcall CMMouseLeave(TMessage *);
	public:
	    __fastcall FCustomButton(TComponent *);
	    void __fastcall SetBounds(int,int,int,int);
	__published:
	    __property Visible;
	    __property Font;
	    __property Color;
	    __property Caption;
	    __property OnClick;
	    __property Enabled;
        __property AnsiString PlusMinus = { read = FPM, write = SetFPM, nodefault };
	BEGIN_MESSAGE_MAP
	    MESSAGE_HANDLER(CM_MOUSEENTER, TMessage *, CMMouseEnter);
	    MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage *, CMMouseLeave);
	END_MESSAGE_MAP(TCustomControl);
	};
// --------------- FCustomButton -----------------------
    void __fastcall SetFBtCaption(AnsiString);
    void __fastcall SetFHeightBegin(int);
    void __fastcall SetFHeightEnd(int);
    void __fastcall SetFPanelUp(Boolean);
    void __fastcall SetFColor(TColor);
    void __fastcall SetFFast(Boolean);
    void __fastcall OnBtClick(TObject *);
    void AnimUp();
    void AnimDown();
    FCustomButton *__fastcall CreateFCustomButton();
    FCustomButton *Bt;
    bool init;
    bool FPanelUp;
    bool FFast;
    bool anim;
    int FHeightBegin;
    int FHeightEnd;
    int FFastValue;
    inline int __pascal GetFast();
    AnsiString FBtCaption;
    TRect rect1;
    TRect rect2;
    TColor FColor;
protected:
    void __fastcall Paint();
public:
	__fastcall FPanel(TComponent* Owner);
    void __fastcall SetBounds(int,int,int,int);
__published:
	__property TColor SignColor = { read = FColor, write = SetFColor, default = clBlack };
    __property OnClick;
    __property OnMouseDown;
    __property OnMouseMove;
    __property OnMouseUp;
    __property int HeightUp = { read = FHeightBegin, write = SetFHeightBegin, default = 24 };
    __property int HeightDown = { read = FHeightEnd, write = SetFHeightEnd, default = 256 };
    __property Boolean PanelUp = { read = FPanelUp, write = SetFPanelUp, default = false };
    __property Boolean Fast = { read = FFast, write = SetFFast, default = false };
    __property AnsiString ButtonCaption = { read = FBtCaption, write = SetFBtCaption, nodefault };
};
//---------------------------------------------------------------------------
#endif
